package itz.componentes;
import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;

public class BotonRedondo extends JButton {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	// Constructor del Botn Redondo
	public BotonRedondo( String rotulo ) {
		super( rotulo );

		// Igualamos las dimensiones para que el botn sea un crculo en vez de
		// una elipse
		Dimension tamano = getPreferredSize();
		tamano.width = tamano.height = Math.max( tamano.width,tamano.height );
		setPreferredSize( tamano );

		// Hacemos que el JButton no pinte su fondo, de este modo podremos
		// nosotros hacer que el color de fondo que se salga de la figura sea
		// del mismo color que el fondo de la ventana
		setContentAreaFilled( false );
	}

	// Este es el mtodo que pinta el botn en el color correspondiente al estado
	// en que se encuentre, y tambin coloca el rtulo que se haya indicado en el
	// centro del botn
	protected void paintComponent( Graphics g ) {
		if( getModel().isArmed() ) {
			// Se puede hacer que la caracterstica de Pulsado sea una propiedad de
			// esta clase
			g.setColor( Color.lightGray );
		} 
		else {
			g.setColor( getBackground() );
		}
		g.fillOval( 0,0,getSize().width-1,getSize().height-1 );

		// Llamando al mtodo de la clase padre, haremos que aparezca el rtulo y
		// hacemos que el restngulo correspondiente al botn sea el que controla
		// el foco
		super.paintComponent( g );
	}

	// Pintamos el borde del botn con una lnea simple
	protected void paintBorder( Graphics g ) {
		g.setColor( getForeground() );
		g.drawOval( 0,0,getSize().width-1,getSize().height-1 );
	}

	// Este es el mtodo que controla la posicin del ratn en el momento de
	// pulsar su botn. Se sobreescribe para controlar los cambios de tamao
	// del botn
	Shape figura;
	public boolean contains( int x,int y ) {
		// En caso de que el botn cambie de tamao, hay que conseguir una nueva
		// figura que se adapte a ese nuevo tamao
		if( figura == null || !figura.getBounds().equals(getBounds()) ) {
			figura = new Ellipse2D.Float( 0,0,getWidth(),getHeight() );
		}
		return( figura.contains( x,y ) );
	}
	
	
}